package h658;

import java.io.OutputStream;
import java.net.Socket;

public class Client {

  public final static String QueueName = "jms.topic.demo";

  public static void main(String[] args) {
    try {
      final Socket socket = new Socket("localhost", 61613);
      final OutputStream os = socket.getOutputStream();
      // 1. Connect
      System.out.println("1. Send a frame with terminating NUL + \\n");
      String text = "CONNECT\n\n\u0000\n";
      os.write(text.getBytes("UTF-8"));
      os.flush();
      System.out.println(
         "Mention here that original StompDecoder (with uncommented logging) makes "+
         "two calls to decode(). The 1st call parses everything upto NUL but leaves "+
         "the terminating \\n, causing expensive System.arraycopy() and secondary "+
         "decode() attempt, which just parses \\n.\nPress Enter."
      );
      System.in.read();

      // 2. Partial sends
      System.out.println("2. Send a frame in parts (happens with some libraries)");
      System.out.println("a. send headers + content");
      text = "SEND\ndestination:"+QueueName+"\ncontent-length:9\n\nSome text";
      os.write(text.getBytes("UTF-8"));
      os.flush();
      Thread.sleep(500);
      System.out.println("b. and terminatin NUL a bit later");
      text = "\u0000\n";
      os.write(text.getBytes("UTF-8"));
      os.flush();
      System.out.println(
        "At step b. original StompDecoder is in incorrent state: its buffer position is -1. " +
        "So is should have fired ArrayIndexOutOfBounds.\nPress Enter."
      );
      System.in.read();

      System.out.println("3. Send a next frame");
      text = "SEND\ndestination:"+QueueName+"\ncontent-length:15\n\nSome other text\u0000\n";
      os.write(text.getBytes("UTF-8"));
      os.flush();
      System.out.println(
        "Since now and on original StompDecoder handles no more frames.\n" +
        "Press Enter."
      );
      System.in.read();

      // Disconnect
      socket.close();
    } catch (Throwable e) {
      e.printStackTrace();
    }
  }
}
